//package sablon;

import java.io.IOException;
import java.lang.Math;
import java.io.PrintStream;

import mester.IO;


public class feladat {

    public feladat() {
    }

    static final int MaxN = 8;
    static final int MaxDB = 100000;

    static class Output {
        int Db;
        int[] x = new int[MaxN];
        int[][] Y = new int[MaxDB][MaxN];
    }

    static void kiir(IO io, Output output) throws IOException {
        final String szoveg = "SENDMORY";
        for (int i = 0; i < output.Db; i++) {
            for (int j = 0; j <= 7; j++) {
                io.write(szoveg.charAt(j) + ":" + output.Y[i][j] + " ");
            }
            io.writeLn("");
        }
    }

    static boolean Volt(int i, int j, int[] x) {
        int k = 1;
        while ((k < i) && (x[k - 1] != j)) {
            k++;
        }
        return (k < i);
    }

    static boolean Jo(int[] x) {
        return x[0] * 1000 +
                x[1] * 91 +
                x[2] * -90 +
                x[3] * 1 +
                x[4] * -9000 +
                x[5] * -900 +
                x[6] * 10 +
                x[7] * -1 == 0;
    }

    static void Osszes_sorrend(int i, int N, Output output) {
        if (i == N + 1) {
            if (Jo(output.x)) {
                for (int j = 0; j < N; j++) {    // Y[Db] = x;
                    output.Y[output.Db][j] = output.x[j];
                }
                output.Db++;
            }
        } else {
            int jj;
            if ((i == 1) || (i == 5)) {
                jj = 1;
            } else {
                jj = 0;
            }
            for (int j = jj; j <= 9; j++) {
                if (!Volt(i, j, output.x)) {
                    output.x[i - 1] = j;
                    Osszes_sorrend(i + 1, N, output);
                }
            }
        }
    }

    static Output Megoldas() {
        Output output = new Output();
        output.Db = 0;
        Osszes_sorrend(1, 8, output);
        return output;
    }

    public static void main(String[] args) throws Exception {
        IO io = new IO();

        Output output = Megoldas();

        kiir(io, output);

        io.close();
    }

}